
/***************************************************************/
// This is the function that created the filter, when the filter has been called.

AVSValue __cdecl Create_TransSide(AVSValue args, void* user_data, IScriptEnvironment* env) 
{

	if(strcmp(args[3].AsString(),"sprite")==0)

			
		return new TransSprite(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),	// Clip as RightClip   
 						args[2].AsInt(),	//overlap of clips. -ve time in seconds, +ve frames
						args[4].AsString("left"),	// Transition direction Left, Right,up, down
						env);
	else if(strcmp(args[3].AsString(),"flippage")==0)
		return new TransFlipPage(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),	// Clip as RightClip
						args[2].AsInt(),	// overlap of clips. -ve time in seconds. +ve frames
 						args[4].AsString("left"),	// Transition direction Left, Right,up, down
						env);
	else if(strcmp(args[3].AsString(),"funnel")==0)
		return new TransFunnel(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),		// Clip as RightClip   
 						args[2].AsInt(),	//overlap of clips. -ve time in seconds, +ve frames
						args[4].AsString("right"),		// Transition direction up, down,left,right																							
						env);
	else if(strcmp(args[3].AsString(),"push")==0)
		return new TransPush(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),	// Clip as RightClip   
 						args[2].AsInt(),	//overlap of clips. -ve time in seconds, +ve frames
						args[4].AsString("left"),	// Transition direction
						env);
	else if(strcmp(args[3].AsString(),"shuffle")==0)

		return new TransShuffle(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),	// Clip as RightClip   
 						args[2].AsInt(),	//overlap of clips. -ve time in seconds, +ve frames
						args[4].AsString("up"),	// Transition direction 
						env);
	else if(strcmp(args[3].AsString(),"wipe")==0)

		return new TransWipe(args[0].AsClip(),	// clip as LeftClip
						args[1].AsClip(),	// Clip as RightClip   
 						args[2].AsInt(),	//overlap of clips. -ve time in seconds, +ve frames
						args[3].AsString("left"),	// Transition direction
						env);
	else
		env->ThrowError("there is no transition function named %s ",args[3].AsString());
// Calls the constructor with the arguments provied.
}
// The following function is the function that actually registers the filter in AviSynth
// It is called automatically, when the plugin is loaded to see which functions this filter contains.
/*
extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
    env->AddFunction("TransSide", "ccis[dir]s", Create_TransSide, 0);
				
    return "TransSprite Transition Mask Plugin";
}
*/
